import arcade

from arcade.gui import UIFlatButton, UIGhostFlatButton, UIManager


class MyView(arcade.View):
    def __init__(self, window: arcade.Window):
        super().__init__()

        self.window = window
        self.ui_manager = UIManager(window)

    def on_draw(self):
        arcade.start_render()
        self.ui_manager.on_draw()

    def on_show_view(self):
        arcade.set_background_color(arcade.color.BLACK)
        self.ui_manager.purge_ui_elements()
        self.ui_manager.enable()

        self.ui_manager.add_ui_element(
            UIFlatButton(
                "Hello world",
                center_x=200,
                center_y=self.window.height // 2,
                min_size=(250, 40),
            )
        )

        self.ui_manager.add_ui_element(
            UIGhostFlatButton(
                "Hello world",
                center_x=600,
                center_y=self.window.height // 2,
                min_size=(250, 40),
            )
        )

    def on_hide_view(self):
        self.ui_manager.disable()


if __name__ == "__main__":
    window = arcade.Window(title="ARCADE_GUI")
    window.show_view(MyView(window))
    arcade.run()
